        /* Copyright (c) 2007 by IBM Corporation */
        
dojo.provide("zero.form.common.components.ActiveWrapper");

dojo.require("zero.form.common.components.BaseWrapper");

dojo.declare("zero.form.common.components.ActiveWrapper", zero.form.common.components.BaseWrapper, {

	    selectionColor: "#EAEFF5",
	    hooverFrameColor:"#3867b4",
		isSelected: false,
		hasFrame: false,
		actionButtons: null,
		
        onmouseover: function(evt)
        {
            if(this.disabled)
				return;
			this.addFrame();
			this.toggleButtonsDisplay(true);
	    },

		addFrame: function()
		{
			if(this.hasFrame)
				return;
			dojo.removeClass(this.mainContainer, "nonVisibleBorder");                        
            dojo.addClass(this.mainContainer, "visibleBorder");
			this.hasFrame = true;	
		},
        
        onmouseout: function(evt)
        {
            if(window.event)// prevent flickering in IE
			{
				evt.cancelBubble = true;
			}
            if(this.disabled)
				return;
			this.removeFrame();
			this.toggleButtonsDisplay(false);
	    },

		toggleButtonsDisplay: function(isVisible)
		{
			var btn;
			var togglingFunction = dojo[((isVisible)?'remove':'add')+"Class"];
			for(var i=0; (btn = this.actionButtons[i]) ; i++)
			{
				togglingFunction(btn,"semi-transparent");
			}			
		},

	    wrapperClicked: function(evt)
	    {
			this.onClick(this.getUid(),evt);
        },	   

        wrapperSelected: function()
        {
			if(this.disabled)
				return;
			this.isSelected  = true;
            this.mainContainer.style.background = this.selectionColor;
			this.addFrame();
        },
        
        wrapperDeselected: function(evt)
        {
			this.isSelected = false;
			this.removeSelectionBackground();
        },

		removeSelectionBackground: function()
		{
			this.mainContainer.style.background = '';
			this.removeFrame();
		},

	    removeFrame: function()
	    {
            if(this.disabled || !this.hasFrame)
				return;
			dojo.removeClass(this.mainContainer, "visibleBorder");                        
            dojo.addClass(this.mainContainer, "nonVisibleBorder");
			this.handleRemoveFrame();
			this.hasFrame = false;
	    },
		
       /* addPressed: function(evt)
        {
			if(this.disabled)
				return;
			this.cloneElement(this);
        },*/
       
        
		setWrapperContainer: function(wrapperContainer)
		{
			this.inherited("setWrapperContainer",arguments);
			this.connects.push(dojo.connect(this, 'onClick', wrapperContainer, 'wrapperSelected'));
            //this.connects.push(dojo.connect(this, 'cloneElement', wrapperContainer, 'cloneWrapper'));
		},
		
		postCreate: function()
		{
            this.inherited("postCreate", arguments);
			this.actionButtons = [];
		//	this.actionButtons.push(this.addButton);
			this.actionButtons.push(this.removeButton);
		},
        
        setDisabled: function(isDisabled)
        {
            this.inherited("setDisabled", arguments);
            if (isDisabled)
            {
                this.removeSelectionBackground();
            }
            this.removeNode.setDisabled(isDisabled);
            //this.addNode.setDisabled(isDisabled);
        },

        postMixInProperties: function()
        {
            this.inherited("postMixInProperties", arguments);
			this.mainContainer = this.mainContainer || this.getMainContainer();
		},

	    clone: function(source){}, // to be overide upon inheritance		
		getMainContainer: function(){}, // an inheriting widget can either define a mainContainer node in its template or overide this method
		handleMouseOver: function(){}, // to be overide upon inheritance
		handleRemoveFrame: function(){}, // to be overide upon inheritance
       // cloneElement: function(wrapper){},//callback, occurs when the user presses on the duplicate field icon
	   	onClick: function(id){}// callback. occurs when the user clicks on the wrapper

});
