/* Copyright (c) 2007 by IBM Corporation */
dojo.provide("zero.form.widget.field.properties.TimeRangePropertyHandlerMixin");

dojo.provide("zero.form.widget.field.properties.RangePropertyHandlerMixin");

dojo.declare(
    "zero.form.widget.field.properties.TimeRangePropertyHandlerMixin", 
	zero.form.widget.field.properties.RangePropertyHandlerMixin,
    {
		_getWidgetMax: function()
		{
			return this._convertHhMmToTime(this.widget.maxValue);
		},
		
		_getWidgetMin: function()
		{
			return this._convertHhMmToTime(this.widget.minValue);
		},

		/**
		 * Converts the given string in format hh:mm or hh:mm:ss to Date object and returns it
		 * if the given string is empty or invalid the empty string is returned
		 * @param {String} pTimeStr the string to convert to Date
		 * @return {Date/String} the date
		 */		
		_convertHhMmToTime: function(pTimeStr)
		{
			if (pTimeStr !== undefined && pTimeStr !== "")
			{
				// parse the time in format hh:mm or hh:mm:ss
				var timeParts = pTimeStr.split(":");
	        	if (timeParts.length == 3 || timeParts.length == 2)
	        	{
	            	var result = new Date();
					result.setTime(0);
					result.setHours(timeParts[0]);
					result.setMinutes(timeParts[1]);
					if (timeParts.length == 3) 
					{
						result.setSeconds(timeParts[2]);
					}
					else
					{
						result.setSeconds(0);
					}
                	return result;
	        	}
			}

			return "";
		}
    }
);
